#! /usr/bin/env ruby

require 'sinatra' 
require './config'	# loads config.rb

raise "Authentication method not defined" unless defined? settings.auth

server = ARGV.shift
user = ARGV.shift
if user =~ /@/ then umail = user else umail = ARGV.shift end
roles = ARGV.shift
pass = ARGV.shift

unless (server != nil) and (user != nil) and (umail != nil) and (roles != nil)
    puts "Syntax: #{__FILE__} [server] [user] [mail] [roles] [password]?
server = URL, for example http://your-database.your-server.com/
roles = admin,search,upload (comma-separated list)
Without password the user will receive an invitation to set password by e-mail"
    exit
end

if pass == nil and umail =~ /@/ then
   pass = '123456'      # send by e-mail and ask to change immediately
   msg_from = settings.send_mail[:from]
   msg_subject = "You are invited to access #{settings.app_name}"
   msg_text = <<"EOF"
Dear #{user},

You have been invited to access to #{settings.app_name}
Access point is #{server}
Your login is #{user} and password is "123456", but the system will ask you to change it immediately

Regards
Administrator for #{settings.app_name}
EOF
   
    require 'net/smtp' 
    require 'mail'
    
    message = Mail.new do
        from msg_from
        to umail
        subject msg_subject
        body msg_text
    end
    
    smtp = settings.send_mail[:smtp]
    Mail.defaults do
        delivery_method :smtp, address: smtp #, port: 1025
    end
    message.deliver
end
pass = '123456' if pass == nil


if defined? settings.auth then
    require "dbm"
    host = server.split(/\./); host = $1.split(/\./) if server =~ /:\/\/(.+)(:\d+)?\/?/
    filename = settings.auth.gsub(/\$HOST\[(\d+)\]/) { num = $1.to_i; host[num - 1] }
    auth_db = DBM.open(filename, 0666, DBM::WRCREAT)
    puts "Writing in auth file #{filename}"

    auth_db[user] = umail + '###' + roles + '###' + pass.crypt('silvestris/consociata')
    auth_db.close
end


exit
